/* prototypes */

static int out_line(byte *, int);
static int decoder(word linewidth);

static int Vindex;      /* Current row address                          */
static FILE *G;                 /* Gif File Input                               */
static byte *pGifBytes;
static int width,height;

#include "decode.c"

static int out_line (byte *pBytes,int linelen)
   {
   memcpy (pGifBytes+Vindex,pBytes,linelen);
   Vindex +=linelen;
   return 1;
   }

// if (Vindex>=200)
//  return -1;
// if (Vindex>=0)
// {
//  if (width<=320)
//   memcpy (pGifBytes+Vindex*320+(320-width)/2,pBytes,linelen);
//  else
//   memcpy (pGifBytes+Vindex*320,
//           pBytes+(width-320)/2,
//           (linelen<320)? linelen:320);
// }
// Vindex++;
// return 1;
//}

//static int out_line (byte *pBytes,int linelen)
//{
// if (Vindex>=200)
//  return -1;
// if (Vindex>=0)
// {
//  if (width<=320)
//   memcpy (pGifBytes+Vindex*320+(320-width)/2,pBytes,linelen);
//  else
//   memcpy (pGifBytes+Vindex*320,
//           pBytes+(width-320)/2,
//           (linelen<320)? linelen:320);
// }
// Vindex++;
// return 1;
//}

int LoadGif(char *szFileName,char *palette,char *pBytes)
{
 int lo,hi;
 int i;
 int num_colours;

pGifBytes=pBytes;
 printf("Opening %s...",szFileName);
 if(!(G=fopen(szFileName,"rb")))
 {
  puts("FAILED\n");
  return 0;
 }
 else
 {
  if ((fgetc(G)!='G') || (fgetc(G)!='I') || (fgetc(G)!='F'))
  {
    puts ("Not a GIF file\n");
   return 0;
  }
  fgetc(G); fgetc(G); fgetc(G);     /* '87a' or '89a' */
  lo=fgetc(G); hi=fgetc(G);
  width=lo+hi*256;
  lo=fgetc(G); hi=fgetc(G);
  height=lo+hi*256;
  Vindex=0; //(200-height)/2;
  i=fgetc(G)&7;
  num_colours=1<<(i+1);
  fgetc(G);                 /* colour index of screen background */
  fgetc(G);                 /* reserved */
  fread (palette,3,num_colours,G);
  for(i=0;i<9;i++)          /* skip 89a stuff */
   fgetc(G);
  if ((fgetc(G)&0x40)==0)
   puts("OK\n");
  else
  {
   puts("ERROR - INTERLACED NOT ALLOWED!\n");
   return 0;
  }
 }
 decoder(width);
 fclose(G);
 return 1;
}

